<?php
class PNFonts
{
	/**
	* Returns array of Google Fonts
	* @return array of Google Fonts
	*/
	static function get_google_font()
	{
		//get google fonts
		$fontsArray = get_option("pn_google_fonts");		
		//update if option doesn't exist or it was modified more than 
		//2 weeks ago (1209600 = 2*7*24*60*60)
		if($fontsArray===false || (time()-$fontsArray->last_update>1209600)) 
		{
			$google_api_url = 'http://quanticalabs.com/.tools/GoogleFont/font.txt';
			$fontsJson = wp_remote_retrieve_body(wp_remote_get($google_api_url, array('sslverify' => false)));
			$fontsArray = json_decode($fontsJson);
			if(is_null($fontsArray))
				return false;
			$fontsArray->last_update = time();		
			update_option("pn_google_fonts", $fontsArray);
		}
		return $fontsArray;
	}
	
	/**
	* Returns array of subsets for provided Google Font
	* @param type $font - Google font
	* @return array of subsets for provided Google Font
	*/
   static function get_google_font_subsets($font)
   {
		$subsets = array();
		//get google fonts
		$fontsArray = PNFonts::get_google_font();
		if($fontsArray===false)
			return false;	   
		$fontsCount = count($fontsArray->items);
		for($i=0; $i<$fontsCount; $i++)
		{
			if($fontsArray->items[$i]->family==$font)
			{
				for($j=0, $max=count($fontsArray->items[$i]->subsets); $j<$max; $j++)
				{
					$subsets[] = $fontsArray->items[$i]->subsets[$j];
				}
				break;
			}
		}
		return $subsets;
   }
}