<?php
class PNNavigationWidget extends WP_Widget 
{
	/** constructor */
    function __construct() 
	{
		$widget_options = array(
			'classname' => 'navigation_widget',
			'description' => 'Displays list of sections on page.'
		);
		
       parent::__construct('pn_navigation_widget', __('Navigation Widget', 'timetable'), $widget_options);
    }
	
	/** @see WP_Widget::widget */
    function widget($args, $instance) 
	{
		global $site_content_navigator;
		if(!$site_content_navigator->pnOptions->enable_sections || !$site_content_navigator->pnOptions->is_post_type_enabled($site_content_navigator->postType))
			return;
		
		extract($args);
		
		$site_content_navigator->navigationWidget = array(
			'sticky'						=>	(isset($instance['sticky']) ? $instance['sticky'] : ''),
			'visible_on_mobile'				=>	(isset($instance['visible_on_mobile']) ? $instance['visible_on_mobile'] : ''),
			'excerpt_length'				=>	(isset($instance['excerpt_length']) ? $instance['excerpt_length'] : ''),
			'header_color'					=>	(isset($instance['header_color']) && strlen($instance['header_color']) ? $instance['header_color'] : '000000'),
			'text_color'					=>	(isset($instance['text_color']) && strlen($instance['text_color']) ? $instance['text_color'] : '9da2a6'),
			'border_color'					=>	(isset($instance['border_color']) && strlen($instance['border_color']) ? $instance['border_color'] : '52b5e7'),
			'background_color'				=>	(isset($instance['background_color']) && strlen($instance['background_color']) ? $instance['background_color'] : 'ffffff'),
			'progress_background_color'		=>	(isset($instance['progress_background_color']) && strlen($instance['progress_background_color']) ? $instance['progress_background_color'] : 'f7f7f7'),
			
		);
		
		//Explanation-3:
		echo $before_widget . '<div id="navigation_widget_wrapper"></div>' . $after_widget;
    }
	
	/** @see WP_Widget::update */
    function update($new_instance, $old_instance) 
	{
		$instance = $old_instance;
		$instance['sticky'] =						(isset($new_instance['sticky']) ? $new_instance['sticky'] : '');
		$instance['visible_on_mobile'] =			(isset($new_instance['visible_on_mobile']) ? $new_instance['visible_on_mobile'] : '');
		$instance['excerpt_length'] =				(isset($new_instance['excerpt_length']) ? $new_instance['excerpt_length'] : '');
		$instance['header_color'] =					(isset($new_instance['header_color']) && strlen($new_instance['header_color']) ? $new_instance['header_color'] : '000000');
		$instance['text_color'] =					(isset($new_instance['text_color']) && strlen($new_instance['text_color']) ? $new_instance['text_color'] : '9da2a6');
		$instance['border_color'] =					(isset($new_instance['border_color']) && strlen($new_instance['border_color']) ? $new_instance['border_color'] : '52b5e7');
		$instance['background_color'] =				(isset($new_instance['background_color']) && strlen($new_instance['background_color']) ? $new_instance['background_color'] : 'ffffff');
		$instance['progress_background_color'] =	(isset($new_instance['progress_background_color']) && strlen($new_instance['progress_background_color']) ? $new_instance['progress_background_color'] : 'f7f7f7');
		return $instance;
    }
	
	 /** @see WP_Widget::form */
	function form($instance) 
	{	
		$sticky =									(isset($instance['sticky']) ? esc_attr($instance['sticky']) : '');
		$visible_on_mobile =						(isset($instance['visible_on_mobile']) ? esc_attr($instance['visible_on_mobile']) : '');
		$excerpt_length =							(isset($instance['excerpt_length']) ? esc_attr($instance['excerpt_length']) : '');
		$header_color =								(isset($instance['header_color']) && strlen($instance['header_color']) ? esc_attr($instance['header_color']) : '000000');
		$text_color =								(isset($instance['text_color']) && strlen($instance['text_color']) ? esc_attr($instance['text_color']) : '9da2a6');
		$border_color =								(isset($instance['border_color']) && strlen($instance['border_color']) ? esc_attr($instance['border_color']) : '52b5e7');
		$background_color =							(isset($instance['background_color']) && strlen($instance['background_color']) ? esc_attr($instance['background_color']) : 'ffffff');
		$progress_background_color =				(isset($instance['progress_background_color']) && strlen($instance['progress_background_color']) ? esc_attr($instance['progress_background_color']) : 'f7f7f7');
		
		echo include(PN_TEMPLATE_PATH . 'navigation_widget_form.php');
	}
}
?>